#!/usr/bin/env python
#-*- coding: utf8 -*-

import socket
import threading
import webbrowser
import time
import os 
import os.path
import Tkinter, tkSimpleDialog, tkFileDialog, tkMessageBox
from functools import partial

try:
    import winsound
    ring = lambda: winsound.PlaySound('ring.wav', winsound.SND_NODEFAULT | winsound.SND_ASYNC)
except ImportError:
    import subprocess
    ring = lambda: subprocess.call(['aplay', 'ring.wav'])

try:
    import cPickle as pickle
except ImportError:
    import Pickle as pickle

HOST = ''
BUFSIZE = 4096
PORT = 65500
VERS = 'TChat 0.2'
IP = None

class Window(Tkinter.Tk):
    def __init__(self, sock):
        Tkinter.Tk.__init__(self)
        self.sock = sock
        self.wm_minsize(width=338, height=400)
        self.wm_maxsize(width=338, height=400)
        self.title(VERS)
        
        #Button的偏函数和Text的偏函数 
        self.Button = partial(Tkinter.Button, height=1, width=5, \
                relief=Tkinter.GROOVE, )
        self.Text = partial(MyText, font=('Helvetica', 11), \
                highlightthickness=0, padx=1, pady=1, )

        #输出窗口
        self.outfrm = Tkinter.Frame(self)
        self.outtex = self.Text(self.outfrm, height=10, width=40)
        self.outtex.tag_config('warning', foreground='red', font=('Helvetica', 9, 'bold'))
        self.outtex.tag_config('remote', foreground='blue')
        self.outscl = Tkinter.Scrollbar(self.outfrm)
        self.outtex['yscrollcommand'] = self.outscl.set
        self.outscl['command'] = self.outtex.yview
        self.outtex.bind('<FocusIn>', self.no_input)
        self.outtex.pack(side=Tkinter.LEFT, fill=Tkinter.BOTH)
        self.outscl.pack(sid=Tkinter.RIGHT, fill=Tkinter.BOTH)
        self.outfrm.grid(row=0, column=0)
       
        #文件传输按钮
        self.trspt_frm = Tkinter.Frame(self)
        self.Button(self.trspt_frm, \
                text='发送文件', \
                command=self.send_file, \
                ).pack(side=Tkinter.LEFT, fill=Tkinter.BOTH)
        self.Button(self.trspt_frm, \
                text='接收文件', \
                command=self.recv_file, \
                ).pack(side=Tkinter.RIGHT, fill=Tkinter.BOTH)
        self.trspt_frm.grid(row=1, column=0, ipadx=20)

        #传输进度框
        self.label_frame = Tkinter.LabelFrame(self, text='传输进度:')
        self.progress_entry = Tkinter.Entry(self.label_frame, \
                highlightthickness=0, \
                relief=Tkinter.FLAT, \
                width=40, \
                fg='red', \
                bg='#D8D8D8', \
                )
        self.progress_entry.bind('<FocusIn>', self.no_input)
        self.progress_entry.pack()
        self.label_frame.grid(row=2, column=0)

        #输入窗口
        self.infrm = Tkinter.Frame(self)
        self.intex = self.Text(self.infrm, height=5, width=30)
        self.inscl = Tkinter.Scrollbar(self.infrm)
        self.intex['yscrollcommand'] = self.inscl.set
        self.inscl['command'] = self.intex.yview
        self.intex.bind('<Return>', self.send_chat)
        self.intex.pack(side=Tkinter.LEFT, fill=Tkinter.BOTH)
        self.inscl.pack(side=Tkinter.RIGHT, fill=Tkinter.BOTH)
        self.infrm.grid(row=3, column=0)
    
        #功能按键的Frame
        self.but2frm = Tkinter.Frame(self)
        self.Button(self.but2frm, 
                text='退出', 
                fg='red', 
                command=self.ask_exit,
                ).pack(side=Tkinter.LEFT, fill=Tkinter.BOTH)
        self.Button(self.but2frm, 
                text='关于', 
                command=self.about, 
                ).pack(side=Tkinter.RIGHT, fill=Tkinter.BOTH)
        self.but2frm.grid(row=5, column=0, ipadx=40, pady=5)
    
    def ask_exit(self):
        if tkMessageBox.askyesno(VERS, '    确认退出？'):
            self.destroy()
    
    def about(self):
        show_about = About()

    #防止用户上屏输入的方法
    def no_input(self, event):
        self.intex.focus_set()
    
    #创建一个接收文件的线程 
    def recv_file(self):
        transport_thread = MyThread(file_in, \
                (self,))
    
    #创建一个发送文件的线程
    def send_file(self):
        file_path = tkFileDialog.askopenfilename(title='选择要发送的文件',\
                filetypes=[('All files', '*')])
        if not file_path:
            return
        file_name = os.path.split(file_path)[1].encode('utf8')
        file_size = os.stat(file_path).st_size
        file_dscrp = open(file_path, 'rb')
        sock.client_sock.send(pickle.dumps('对方要发送文件，若接收请点[接收文件]。', 2))
        self.outtex.my_insert('end', '等待对方同意...\n', 'warning')
        transport_thread = MyThread(file_out, \
                (self, file_dscrp, (file_name, file_size)))
    
    def send_chat(self, event):
        '''发送信息
        '''
        data = self.intex.get(1.0, 'end').strip().encode('utf8')
        if not data:
            self.intex.delete(1.0, 'end')
            return 'break'
        pickle_data = pickle.dumps(data, 2)
        self.sock.client_sock.send(pickle_data)
        self.outtex.my_insert('end', data+'\n')
        self.intex.delete(1.0, 'end')
        return 'break'

class About(object):
    def __init__(self):
        top = Tkinter.Toplevel()
        top.title('关于TChat')
        top.geometry('240x200+300+200')
        self.about_text = Tkinter.Text(top, cursor='hand2')
        self.about_text.pack(fill='both', expand=1)
        self.info_list = ['\nTChat 0.2\n\n',
                    '一个跨平台的半即时聊天工具\n',
                    'http://code.google.com/p/tchat-python/\n\n',
                    '(c) 2010, zkwlx\n', 
                    '< zkwlxcode@gmail.com >',
                    ]
        self.about_text.tag_config('name', justify='center', font=('Helvetica', 16, 'bold'))
        self.about_text.tag_config('info', justify='center', font=('Helvetica', 9))
        self.about_text.tag_config('url', justify='center', font=('Helvetica', 10), \
                foreground='blue', underline=1)
        self.about_text.tag_bind('url', '<Button>', self.browser)
        
        self.about_text.insert('end', self.info_list[0], 'name')
        self.about_text.insert('end', self.info_list[1], 'info')
        self.about_text.insert('end', self.info_list[2], 'url')
        self.about_text.insert('end', self.info_list[3], 'info')
        self.about_text.insert('end', self.info_list[4], 'info')
        self.about_text['state'] = 'disabled'

    def browser(self, event):
        webbrowser.open(self.info_list[2])

class MyText(Tkinter.Text):
    def my_insert(self, index, chars, *args):
        self.insert(index, chars, *args)
        self.yview('end')

class MyThread(threading.Thread):
    def __init__(self, func, argv, dae=True):
        threading.Thread.__init__(self)
        self.func = func
        self.argv = argv
        self.setDaemon(dae)
        self.start()

    def run(self):
        self.func(*self.argv)

class TranChat(socket.socket):
    def server(self, locaddr, window):
        self.bind(locaddr)
        self.listen(1)
        window.outtex.insert('end', '正在等待连接，请稍后..\n', 'warning')
        self.client_sock, remaddr = self.accept()
        self.close()
        global IP
        IP = remaddr[0]
        window.outtex.insert('end', '已接受：%s的连接\n'%IP, 'warning')
        flag = 1
        while flag:
            dat = self.client_sock.recv(1024)
            dat = pickle.loads(dat)
            flag = self.recv_chat(dat, window)

    def client(self, remaddr, window):
        window.outtex.insert('end', '正在连接，请稍后..\n', 'warning')
        if connect_check(self, remaddr) == 0:
            window.outtex.insert('end', '连接超时！\n', 'warning')
            return
        window.outtex.insert('end', '已连接到：%s\n'%remaddr[0], 'warning')
        flag = 1
        while flag:
            dat = self.recv(1024)
            dat = pickle.loads(dat)
            flag = self.recv_chat(dat, window)
    
    #为client和server提供聊天信息接收功能
    def recv_chat(self, dat, window):    
        if dat == 'SOCKET CLOSE':
            window.outtex.my_insert('end', '对方已断开连接！', 'warning')
            return 0
        dat = dat.decode('utf8')
        if not window.intex.focus_get():
            ring()
        window.outtex.my_insert('end', dat+'\n', 'remote')
        return 1

#文件接收
def file_in(window):
    window.outtex.my_insert('end', '准备接收...\n', 'warning')
    transpt_in_sock = link_process()
    if transpt_in_sock == 0:
        window.outtex.my_insert('end', '连接超时！\n', 'warning')
        return
    window.outtex.my_insert('end', '等待对方发送，请稍后..\n', 'warning')
    file_info = transpt_in_sock.recv(BUFSIZE)
    file_name, file_size = pickle.loads(file_info)
    file_name = file_name.decode('utf8')
    file_recv = open(file_name, 'wb')
    init_len = len('接收进度：%s/'%file_size)-9
    window.progress_entry.insert(0, '接收进度：%s/ '%file_size)
    current_size = 0
    window.outtex.my_insert('end', '开始接收...\n', 'warning')
    try:
        while 1:
            peer = transpt_in_sock.recv(BUFSIZE)
            file_recv.write(peer)
            current_size += len(peer)
            window.progress_entry.delete(init_len, 'end')
            window.progress_entry.insert(init_len, str(current_size))
            if file_size == current_size:
                transpt_in_sock.send('EOF')
                break
    finally:
        file_recv.close()
        transpt_in_sock.close()
    window.outtex.my_insert('end', '文件接收完毕！保存在当前目录下。\n', 'warning')

#文件发送
def file_out(window, file_dscrp, file_info):
    transpt_out_sock = link_process()
    if transpt_out_sock == 0:
        window.outtex.my_insert('end', '连接超时！\n', 'warning')
        return
    file_size = file_info[1]
    window.outtex.my_insert('end', '开始发送文件...\n', 'warning')
    info = pickle.dumps(file_info, 2)
    transpt_out_sock.sendall(info)
    init_len = len('发送进度：%s/'%file_size)-9
    window.progress_entry.insert(0, '发送进度：%s/ '%file_size)
    while 1:
        window.progress_entry.delete(init_len, 'end')
        window.progress_entry.insert(init_len, str(file_size))
        peer = file_dscrp.read(BUFSIZE)
        if not peer:
            break
        elif not file_size <= BUFSIZE:
            file_size -= BUFSIZE
        else:
            file_size -= len(peer)
        transpt_out_sock.send(peer)
    file_dscrp.close()
    while 1:
        flag = transpt_out_sock.recv(1024)
        if flag == 'EOF':
            break
    transpt_out_sock.close()
    window.outtex.my_insert('end', '文件发送完毕！\n', 'warning')


def connect_check(sock, addr):
    i = 0
    while True:
        if sock.connect_ex(addr) == 0:
            return sock
        elif i >= 14: #尝试15次
            return 0 #这里代表连接失败
        i += 1
        time.sleep(0.7)

def server_trans():
    temp_sock = socket.socket()
    temp_sock.setsockopt(socket.SOL_SOCKET, socket.SO_REUSEADDR, 1)
    temp_sock.bind((HOST, PORT+1))
    temp_sock.listen(1)
    remote_sock = temp_sock.accept()[0]
    temp_sock.close()
    return remote_sock

def client_trans():
    temp_sock = socket.socket()
    temp_sock.setsockopt(socket.SOL_SOCKET, socket.SO_REUSEADDR, 1)
    local_sock  = connect_check(temp_sock, (IP, PORT+1))
    return local_sock


def main(sock):
    global IP
    global link_process #这个代表server_trans 和client_trans 其中一个，文件传输要用到这个函数
    window = Window(sock)
    window.protocol('WM_DELETE_WINDOW', window.ask_exit)
    window.geometry('+100+100')
    window.update()
    IP = tkSimpleDialog.askstring(title=VERS, \
            prompt='请输入对方IP,并点[Ok]连接到对方\n或点[Cancel]等待对方连接')
    if IP:
        link_process = client_trans
        thread_chat = MyThread(sock.client, ((IP, PORT), window))
    else:
        link_process = server_trans
        threadchat = MyThread(sock.server, ((HOST, PORT), window))
    
    window.mainloop()
    
    try:
        sock.client_sock.sendall(pickle.dumps('SOCKET CLOSE', 2))
    except IOError:
        pass

    sock.close()

if __name__ == '__main__':
    sock = TranChat()
    sock.setsockopt(socket.SOL_SOCKET, socket.SO_REUSEADDR, 1)
    sock.client_sock = sock #只是为了传输文件的时候S/C端共用一个socket的命名
    try:
        main(sock)
    except KeyboardInterrupt:
        pass
